# bitmath_func.hpp File Reference

Functions related to bit mathematics. More...

Go to the source code of this file.

## Defines
#define | HASBITS(x, y) (((x) & (y)) != 0)
| Check several bits in a value.
#define | SETBITS(x, y) ((x) |= (y))
| Sets several bits in a variable.
#define | CLRBITS(x, y) ((x) &= ~(y))
| Clears several bits in a variable.
#define | FIND_FIRST_BIT(x) _ffb_64[(x)]
| Returns the first occure of a bit in a 6-bit value (from right).
#define | FOR_EACH_SET_BIT(i, b)
| Do an operation for each set set bit in a value.
## Functions
template<typename T>
static FORCEINLINE uint | GB (const T x, const uint8 s, const uint8 n)
| Fetch n bits from x, started at bit s.
template<typename T, typename U>
static FORCEINLINE T | SB (T &x, const uint8 s, const uint8 n, const U d)
| Set n bits in x starting at bit s to d.
template<typename T, typename U>
static FORCEINLINE T | AB (T &x, const uint8 s, const uint8 n, const U i)
| Add i to n bits of x starting at bit s.
template<typename T>
static FORCEINLINE bool | HasBit (const T x, const uint8 y)
| Checks if a bit in a value is set.
template<typename T>
static FORCEINLINE T | SetBit (T &x, const uint8 y)
| Set a bit in a variable.
template<typename T>
static FORCEINLINE T | ClrBit (T &x, const uint8 y)
| Clears a bit in a variable.
template<typename T>
static FORCEINLINE T | ToggleBit (T &x, const uint8 y)
| Toggles a bit in a variable.
static FORCEINLINE uint8 | FindFirstBit2x64 (const int value)
| Finds the position of the first bit in an integer.
uint8 | FindFirstBit (uint32 x)
| Search the first set bit in a 32 bit variable.
uint8 | FindLastBit (uint64 x)
| Search the last set bit in a 64 bit variable.
template<typename T>
static FORCEINLINE T | KillFirstBit (T value)
| Clear the first bit in an integer.
template<typename T>
static uint | CountBits (T value)
| Counts the number of set bits in a variable.
template<typename T>
static FORCEINLINE T | ROL (const T x, const uint8 n)
| ROtate x Left by n.
template<typename T>
static FORCEINLINE T | ROR (const T x, const uint8 n)
| ROtate x Right by n.
static FORCEINLINE uint32 | BSWAP32 (uint32 x)
| Perform a 32 bits endianness bitswap on x.
static FORCEINLINE uint16 | BSWAP16 (uint16 x)
| Perform a 16 bits endianness bitswap on x.
## Variables
const uint8 | _ffb_64 [64]
| Lookup table to check which bit is set in a 6 bit variable.

## Detailed Description

Functions related to bit mathematics.

Definition in file bitmath_func.hpp.

## Define Documentation

#define CLRBITS | ( | x,
|  | y |  | ) | ((x) &= ~(y))

Clears several bits in a variable.

This macro clears several bits in a variable. The bits to clear are provided by a value. The new value is also returned.

Parameters:

  | x | The variable to clear some bits
  | y | The value with set bits for clearing them in the variable

Returns:
  The new value of x

Definition at line 162 of file bitmath_func.hpp.

Referenced by CheckRoadSlope(), and DisasterTick_Zeppeliner().

#define FIND_FIRST_BIT | ( | x |  | ) | _ffb_64[(x)]

Returns the first occure of a bit in a 6-bit value (from right).

Returns the position of the first bit that is not zero, counted from the LSB. Ie, 110100 returns 2, 000001 returns 0, etc. When x == 0 returns 0.

Parameters:

  | x | The 6-bit value to check the first zero-bit

Returns:
  The first position of a bit started from the LSB or 0 if x is 0.

Definition at line 195 of file bitmath_func.hpp.

Referenced by FindFirstBit2x64(), FindFirstTrack(), FloodHalftile(), RemoveFirstTrack(), and TrackBitsToTrack().

#define FOR_EACH_SET_BIT | ( | i,
|  | b |  | ) |

Value:

    for (i = 0; b != 0; i++, b >>= 1) \
        if (b & 1)

Do an operation for each set set bit in a value.

This macros is used to do an operation for each set bit in a variable. The first variable can be reused in the operation due to it's the bit position counter. The second variable will be cleared during the usage

Parameters:

  | i | The position counter
  | b | The value which we check for set bits

Definition at line 301 of file bitmath_func.hpp.

Referenced by CompanyStationsWindow::OnClick(), RoadFindPathToDest(), and TileLoop_Water().

#define HASBITS | ( | x,
|  | y |  | ) | (((x) & (y)) != 0)

Check several bits in a value.

This macro checks if a value contains at least one bit of an other value.

Parameters:

  | x | The first value
  | y | The second value

Returns:
  True if at least one bit is set in both values, false else.

Definition at line 104 of file bitmath_func.hpp.

Referenced by AddGRFString(), AirportSetBlocks(), BuildTownHouse(), CmdAutoreplaceVehicle(), CmdBuildRailWagon(), CmdMoveRailVehicle(), CmdSellAircraft(), CmdSellRailWagon(), CmdSellRoadVeh(), CmdSellShip(), and GrowTownWithBridge().

#define SETBITS | ( | x,
|  | y |  | ) | ((x) |= (y))

Sets several bits in a variable.

This macro sets several bits in a variable. The bits to set are provided by a value. The new value is also returned.

Parameters:

  | x | The variable to set some bits
  | y | The value with set bits for setting them in the variable

Returns:
  The new value of x

Definition at line 133 of file bitmath_func.hpp.

Referenced by AirportSetBlocks(), and DisasterTick_Zeppeliner().

## Function Documentation

template<typename T, typename U>

static FORCEINLINE T AB | ( | T & | x,
|  | const uint8 | s,
|  | const uint8 | n,
|  | const U | i |
| ) |  |  | `[inline, static]`

Add i to n bits of x starting at bit s.

This add the value of i on n bits of x starting at bit s. The parameters x, s, i are similar to GB besides x must be a variable as the result are saved there. An overflow does not affect the following bits of the given bit window and is simply ignored.

Note:
  Parameter x must be a variable as the result is saved there.

Parameters:

  | x | The variable to add some bits at some position
  | s | The startposition of the addition
  | n | The size/window for the addition
  | i | The value to add at the given startposition in the given window.

Returns:
  The new value of x

Definition at line 70 of file bitmath_func.hpp.

Referenced by IncHouseConstructionTick().

static FORCEINLINE uint16 BSWAP16 | ( | uint16 | x | ) | `[static]`

Perform a 16 bits endianness bitswap on x.

Parameters:

  | x | the variable to bitswap

Returns:
  the bitswapped value.

Definition at line 334 of file bitmath_func.hpp.

static FORCEINLINE uint32 BSWAP32 | ( | uint32 | x | ) | `[static]`

Perform a 32 bits endianness bitswap on x.

Parameters:

  | x | the variable to bitswap

Returns:
  the bitswapped value.

Definition at line 319 of file bitmath_func.hpp.

Referenced by GamelogPrint(), GetNewEngine(), HandleSavegameLoadCrash(), IsGoodGRFConfigList(), NewGRFWindow::OnClick(), PrintGrfInfo(), and SlArray().

template<typename T>

static FORCEINLINE T ClrBit | ( | T & | x,
|  | const uint8 | y |
| ) |  |  | `[inline, static]`

Clears a bit in a variable.

This function clears a bit in a variable. The variable is changed and the value is also returned. Parameter y defines the bit to clear and starts at the LSB with 0.

Parameters:

  | x | The variable to clear the bit
  | y | The bit position to clear

Returns:
  The new value of the old value with the bit cleared

Definition at line 147 of file bitmath_func.hpp.

Referenced by RoadStop::AllocateBay(), RoadStop::AllocateDriveThroughBay(), ClearArticulatedPart(), ClearFreeWagon(), ClearFrontEngine(), ClearMultiheaded(), ClearSingleBridgeMiddle(), ClearTrainEngine(), ClearTrainWagon(), CmdAutofillTimetable(), CmdBuildRailroadTrack(), ConvertOldMultiheadToNew(), CopyGRFConfigList(), DrawCatenaryRailway(), GraphicsNew(), LoadUnloadVehicle(), MapSpriteMappingRecolour(), NPFSetFlag(), RemoveFirstTrack(), RemoveFirstTrackdir(), ToggleInvisibilityWithTransparency(), TrainConsistChanged(), TryPathReserve(), UpdateTownGrowRate(), and VehiclePayment().

template<typename T>

static uint CountBits | ( | T | value | ) | `[inline, static]`

Counts the number of set bits in a variable.

Parameters:

  | value | the value to count the number of bits in.

Returns:
  the number of bits.

Definition at line 246 of file bitmath_func.hpp.

Referenced by CheckRoadSlope(), CleanUpRoadBits(), CmdBuildRoad(), CmdBuildRoadStop(), CmdConvertRail(), DrawRoadBits(), AIStation::GetCoverageRadius(), AIStation::HasStationType(), AITile::IsBuildable(), RemoveRoad(), ShowRefitOptionsList(), and UpdateCompanyRatingAndValue().

uint8 FindFirstBit | ( | uint32 | x | ) |

Search the first set bit in a 32 bit variable.

This algorithm is a static implementation of a log conguence search algorithm. It checks the first half if there is a bit set search there further. And this way further. If no bit is set return 0.

Parameters:

  | x | The value to search

Returns:
  The position of the first bit set

Definition at line 30 of file bitmath_func.cpp.

Referenced by AllocateMap(), and ExploreSegment().

static FORCEINLINE uint8 FindFirstBit2x64 | ( | const int | value | ) | `[static]`

Finds the position of the first bit in an integer.

This function returns the position of the first bit set in the integer. It does only check the bits of the bitmask 0x3F3F (0011111100111111) and checks only the bits of the bitmask 0x3F00 if and only if the lower part 0x00FF is 0. This results the bits at 0x00C0 must be also zero to check the bits at 0x3F00.

Parameters:

  | value | The value to check the first bits

Returns:
  The position of the first bit which is set

See also:
  FIND_FIRST_BIT

Definition at line 211 of file bitmath_func.hpp.

References FIND_FIRST_BIT.

Referenced by CYapfBaseT< Types >::AddMultipleNodes(), FindFirstTrackdir(), CYapfOriginTileT< Types >::PfSetStartupNodes(), RemoveFirstTrackdir(), and RoadFindPathToDest().

uint8 FindLastBit | ( | uint64 | x | ) |

Search the last set bit in a 64 bit variable.

This algorithm is a static implementation of a log conguence search algorithm. It checks the second half if there is a bit set search there further. And this way further. If no bit is set return 0.

Parameters:

  | x | The value to search

Returns:
  The position of the last bit set

Definition at line 58 of file bitmath_func.cpp.

template<typename T>

static FORCEINLINE uint GB | ( | const T | x,
|  | const uint8 | s,
|  | const uint8 | n |
| ) |  |  | `[inline, static]`

Fetch n bits from x, started at bit s.

This function can be used to fetch n bits from the value x. The s value set the startposition to read. The startposition is count from the LSB and starts at 0. The result starts at a LSB, as this isn't just an and-bitmask but also some bit-shifting operations. GB(0xFF, 2, 1) will so return 0x01 (0000 0001) instead of 0x04 (0000 0100).

Parameters:

  | x | The value to read some bits.
  | s | The startposition to read some bits.
  | n | The number of bits to read.

Returns:
  The selected bits, aligned to a LSB.

Definition at line 25 of file bitmath_func.hpp.

Referenced by AreCompanyManagerFaceBitsValid(), BmpRead1(), BmpRead24(), BmpRead4(), BmpRead4Rle(), BmpRead8(), BuildTownHouse(), ChangeIndustryProduction(), CmdAutofillTimetable(), CmdBuildAirport(), CmdBuildBridge(), CmdBuildDock(), CmdBuildIndustry(), CmdBuildLongRoad(), CmdBuildRailroadStation(), CmdBuildRoad(), CmdBuildRoadDepot(), CmdBuildRoadStop(), CmdBuildSingleSignal(), CmdBuildTown(), CmdBuildTunnel(), CmdChangeTimetable(), CmdCloneOrder(), CmdCompanyCtrl(), CmdDepotMassAutoReplace(), CmdDepotSellAllVehicles(), CmdInsertOrder(), CmdMassStartStopVehicle(), CmdModifyOrder(), CmdMoveOrder(), CmdMoveRailVehicle(), CmdOrderRefit(), CmdPlantTree(), CmdRailTrackHelper(), CmdRefitAircraft(), CmdRefitRailVehicle(), CmdRefitRoadVeh(), CmdRefitShip(), CmdRemoveLongRoad(), CmdRemoveRoad(), CmdRemoveRoadStop(), CmdRemoveSingleSignal(), CmdRestoreOrderIndex(), CmdSetAutoReplace(), CmdSetCompanyColour(), CmdSetVehicleOnTime(), CmdSignalTrackHelper(), CmdStartStopVehicle(), ConvertFromOldCompanyManagerFace(), CopyFromOldName(), Disaster_CoalMine_Init(), DisasterTick_Airplane(), DisasterTick_Big_Ufo_Destroyer(), DisasterTick_Helicopter(), DisasterTick_Submarine(), DisasterTick_Zeppeliner(), DoCommandP(), DoPlaceMoreTrees(), DrawSprite(), DrawStringMultiCenter(), Window::DrawWidgets(), GamelogPrint(), GenRandomRoadBits(), GetAiPurchaseCallbackResult(), GetBridgeAxis(), GetBridgeType(), AICargo::GetCargoLabel(), GetCargoSuffix(), GetClearCounter(), GetClearDensity(), GetClearGround(), GetCompanyHQSection(), GetCompanyHQSize(), GetCompanyManagerFaceBits(), GetCompanyManagerFaceSprite(), GetCountAndDistanceOfClosestInstance(), GetDisallowedRoadDirections(), GetDistanceFromNearbyHouse(), GetFenceSE(), GetFenceSW(), GetFieldType(), GetGlobalVariable(), GetHouseAnimationFrame(), GetHouseBuildingStage(), GetHouseConstructionTick(), GetHouseTriggers(), GetHouseType(), GetIndustryConstructionCounter(), GetIndustryConstructionStage(), GetIndustryTriggers(), GetIntersectionOfArticulatedRefitMasks(), GetLiftDestination(), GetLiftPosition(), GetPresentSignals(), GetRailDepotDirection(), GetRailTileType(), GetRailType(), GetSignalStates(), GetStringHeight(), GetStringWithArgs(), GetTileType(), GetTrackBits(), GetTrackReservation(), GetTreeCount(), GetTreeCounter(), GetTreeDensity(), GetTreeGround(), GetTreeGrowth(), GetTropicZone(), GetTunnelBridgeDirection(), GetTunnelBridgeTransportType(), GetUnicodeGlyph(), GetUnionOfArticulatedRefitMasks(), GetWaypointAxis(), GfxFillRect(), HandleAutoSignalPlacement(), HandleKeypress(), RoadStop::HasFreeBay(), HeightMapNormalize(), IncHouseConstructionTick(), IndustryGetVariable(), AIOrder::InsertOrder(), IsArticulatedVehicleRefittable(), IsBridgeAbove(), Load_VEHS(), LoadChunk(), LoadUnloadVehicle(), MapGRFStringID(), MirrorRoadBits(), Randomizer::Next(), VehicleListWindow::OnClick(), VehicleListWindow::OnDropdownSelect(), VehicleListWindow::OnInvalidateData(), VehicleListWindow::OnPaint(), VehicleListWindow::OnTick(), PlaceExtraDepotRail(), PlaceMoreTrees(), PlaceTree(), PlaceTreeAtSameHeight(), PrepareTextRefStackUsage(), ResetRestoreAllTransparency(), ResizeWindow(), RotateRoadBits(), ScaleAllCompanyManagerFaceBits(), SetHouseAnimationFrame(), SetHouseType(), SetIndustryGfx(), SetUnicodeGlyph(), SlCalcConvFileLen(), SlCalcConvMemLen(), AIError::StringToError(), TileHash2Bit(), TileHeight(), TileLoop_Town(), TownGetVariable(), TownHouseChangeInfo(), TrainCheckIfLineEnds(), TrainConsistChanged(), UnpackVersion4Order(), Utf8EncodedCharLen(), VehicleFromPos(), VehicleFromPosXY(), and VehicleRandomBits().

template<typename T>

static FORCEINLINE bool HasBit | ( | const T | x,
|  | const uint8 | y |
| ) |  |  | `[inline, static]`

Checks if a bit in a value is set.

This function checks if a bit inside a value is set or not. The y value specific the position of the bit, started at the LSB and count from 0.

Parameters:

  | x | The value to check
  | y | The position of the bit to check, started from the LSB

Returns:
  True if the bit is set, false else.

Definition at line 89 of file bitmath_func.hpp.

Referenced by AfterLoadVehicles(), AIEngineList::AIEngineList(), AITileList_StationType::AITileList_StationType(), RoadStop::AllocateBay(), AIRoad::AreRoadTilesConnected(), AreValidRoadTypes(), BuildReplacementVehicle(), CompanyStationsWindow::BuildStationsList(), BuildTownHouse(), CalcPercentVehicleFilled(), CalculateRefitMasks(), AIRoad::CanBuildConnectedRoadPartsHere(), CanBuildVehicleInfrastructure(), CanCargoServiceIndustry(), CFollowTrackT< Ttr_type_, T90deg_turns_allowed_, Tmask_reserved_tracks >::CanEnterNewTile(), CanEnterTile(), CanRefitTo(), CanRemoveRoadWithStop(), ChangeIndustryProduction(), CheckAutoreplaceValidity(), CheckFlatLandBelow(), CheckRoadBlockedForOvertaking(), CheckSendAircraftToHangarForReplacement(), CmdAutofillTimetable(), CmdBuildAircraft(), CmdBuildAirport(), CmdBuildDock(), CmdBuildLongRoad(), CmdBuildRailroadStation(), CmdBuildRailVehicle(), CmdBuildRoad(), CmdBuildRoadStop(), CmdBuildRoadVeh(), CmdBuildSingleRail(), CmdBuildSingleSignal(), CmdBuildTown(), CmdBuildTrainWaypoint(), CmdChangeTimetable(), CmdCloneVehicle(), CmdDepotMassAutoReplace(), CmdDoTownAction(), CmdMassStartStopVehicle(), CmdMoveRailVehicle(), CmdRailTrackHelper(), CmdRefitAircraft(), CmdRefitRailVehicle(), CmdRefitRoadVeh(), CmdRefitShip(), CmdRemoveLongRoad(), CmdReverseTrainDirection(), CmdSetAutoReplace(), CmdSetGroupReplaceProtection(), CmdSignalTrackHelper(), CmdStartStopVehicle(), ConvertFromOldCompanyManagerFace(), ConvertOldMultiheadToNew(), CreateNewIndustryHelper(), DeleteLastWagon(), DisasterTick_Airplane(), DisasterTick_Helicopter(), DisasterTick_Helicopter_Rotors(), DisasterTick_Submarine(), DisasterTick_Ufo(), DisasterTick_Zeppeliner(), SettingEntry::Draw(), DrawBridgePillars(), DrawCatenaryRailway(), DrawCompanyManagerFace(), DrawRoadBits(), DrawSprite(), DrawStationTile(), DrawTile_Road(), DrawTile_TunnelBridge(), FindFirstRefittableCargo(), FindTrainOnTrackEnum(), FixTTOEngines(), GetAcceptanceMask(), GetCargoSubtypeText(), GetCargoSuffix(), GetCompanyRailtypes(), GetCompanyRoadtypes(), GetCrossingReservation(), GetDepotWaypointReservation(), GetDriveableTrackdirBits(), GetIntersectionOfArticulatedRefitMasks(), GetMaskOfTownActions(), GetNewCargoTypeForReplace(), GetRailwayStationReservation(), AITown::GetRating(), AIEngine::GetRoadType(), GetSingleSignalState(), GetStringWithArgs(), GetTileSingleEntry(), GetTrackReservation(), GetTrainAcceleration(), GetTunnelBridgeReservation(), GetUnionOfArticulatedRefitMasks(), GraphicsNew(), GroundSpritePaletteTransform(), HandleSavegameLoadCrash(), HasCatenary(), HasPowerOnRail(), HasRailtypeAvail(), AITown::HasStatue(), HasTrack(), HasTunnelBridgeSnowOrDesert(), HeightMapCoastLines(), HeightMapSmoothCoasts(), IndustryGetVariable(), AITown::IsActionAvailable(), IsArticulatedPart(), IsArticulatedVehicleRefittable(), IsBridge(), IsCompatibleRail(), IsEngineBuildable(), IsEngineRefittable(), RoadStop::IsEntranceBusy(), RoadStop::IsFreeBay(), IsFreeWagon(), IsFrontEngine(), IsGoodGRFConfigList(), IsHouseCompleted(), IsIndustryCompleted(), IsInvisibilitySet(), IsLoggableGrfConfig(), IsMultiheaded(), IsSignalPresent(), IsTrainEngine(), IsTrainWagon(), IsTransparencySet(), IsTunnel(), IsUphillTrackdir(), AIAirport::IsValidAirportType(), IsValidCompanyManagerFace(), AIEngine::IsValidEngine(), Window::IsWidgetDisabled(), Window::IsWidgetHidden(), Window::IsWidgetLowered(), LiftHasDestination(), LoadUnloadVehicle(), make_manyofmany(), MakeSingleHouseBigger(), MapSpriteMappingRecolour(), MarkTrainAsStuck(), NPFGetFlag(), NewGRFWindow::OnClick(), ReplaceVehicleWindow::OnClick(), VehicleListWindow::OnInvalidateData(), StationViewWindow::OnPaint(), CompanyStationsWindow::OnPaint(), NewGRFWindow::OnPaint(), PopupMainCompanyToolbMenu(), RailVehicleChangeInfo(), RailVehicleLengthChanged(), RandomCompanyManagerFaceBits(), RemoveRoad(), ResetIndustries(), RoadFindPathToDest(), ScaleAllCompanyManagerFaceBits(), ShipVehicleChangeInfo(), ShowNewGrfVehicleError(), ShowRefitOptionsList(), SlReadSimpleGamma(), SpriteLayoutPaletteTransform(), CompanyStationsWindow::StationRatingMaxSorter(), CompanyStationsWindow::StationWaitingSorter(), TileLoop_Town(), TileLoop_Water(), TrackOverlapsTracks(), TrainCargoChanged(), TrainConsistChanged(), TrainExitDir(), TrainPowerChanged(), TriggerIndustryProduction(), TryPathReserve(), UpdateStationAcceptance(), UpdateTrainSpeed(), VehiclePayment(), and VerifyAutoreplaceRefitForOrders().

template<typename T>

static FORCEINLINE T KillFirstBit | ( | T | value | ) | `[inline, static]`

Clear the first bit in an integer.

This function returns a value where the first bit (from LSB) is cleared. So, 110100 returns 110000, 000001 returns 000000, etc.

Parameters:

  | value | The value to clear the first bit

Returns:
  The new value with the first bit cleared

Definition at line 234 of file bitmath_func.hpp.

Referenced by CYapfBaseT< Types >::AddMultipleNodes(), AIRail::BuildRailTrack(), CheckAllowRemoveRoad(), CheckNextTrainTile(), CmdBuildSingleSignal(), ExtendTrainReservation(), IsSafeWaitingPosition(), CYapfOriginTileT< Types >::PfSetStartupNodes(), AIRail::RemoveRailTrack(), RoadFindPathToDest(), TrackBitsToTrack(), and TracksOverlap().

template<typename T>

static FORCEINLINE T ROL | ( | const T | x,
|  | const uint8 | n |
| ) |  |  | `[inline, static]`

ROtate x Left by n.

Note:
  Assumes a byte has 8 bits

Parameters:

  | x | The value which we want to rotate
  | n | The number how many we waht to rotate

Returns:
  A bit rotated number

Definition at line 271 of file bitmath_func.hpp.

Referenced by VerifyOldNameChecksum().

template<typename T>

static FORCEINLINE T ROR | ( | const T | x,
|  | const uint8 | n |
| ) |  |  | `[inline, static]`

ROtate x Right by n.

Note:
  Assumes a byte has 8 bits

Parameters:

  | x | The value which we want to rotate
  | n | The number how many we waht to rotate

Returns:
  A bit rotated number

Definition at line 285 of file bitmath_func.hpp.

Referenced by Randomizer::Next().

template<typename T, typename U>

static FORCEINLINE T SB | ( | T & | x,
|  | const uint8 | s,
|  | const uint8 | n,
|  | const U | d |
| ) |  |  | `[inline, static]`

Set n bits in x starting at bit s to d.

This function sets n bits from x which started as bit s to the value of d. The parameters x, s and n works the same as the parameters of GB. The result is saved in x again. Unused bits in the window provided by n are set to 0 if the value of d isn't "big" enough. This is not a bug, its a feature.

Note:
  Parameter x must be a variable as the result is saved there.

  To avoid unexpecting results the value of d should not use more space as the provided space of n bits (log2)

Parameters:

  | x | The variable to change some bits
  | s | The startposition for the new bits
  | n | The size/window for the new bits
  | d | The actually new bits to save in the defined position.

Returns:
  The new value of x

Definition at line 48 of file bitmath_func.hpp.

Referenced by CmdSignalTrackHelper(), GenericPlaceSignals(), GetGlobalVariable(), HaltLift(), HandleAutoSignalPlacement(), IndustryProductionCallback(), LoadUnloadVehicle(), MakeBridgeRamp(), MakeClear(), MakeField(), MakeRailTunnel(), MakeRoadTunnel(), MakeTree(), MakeUnmovable(), VehicleListWindow::OnInvalidateData(), RailVehicleChangeInfo(), ResetIndustryConstructionStage(), SetClearCounter(), SetCompanyHQSection(), SetCompanyHQSize(), SetCompanyManagerFaceBits(), SetCrossingReservation(), SetDepotWaypointReservation(), SetDisallowedRoadDirections(), RoadStop::SetEntranceBusy(), SetFenceSE(), SetFenceSW(), SetFieldType(), SetHasSignals(), SetHouseAnimationFrame(), SetHouseCompleted(), SetHouseTriggers(), SetHouseType(), SetIndustryCompleted(), SetIndustryConstructionCounter(), SetIndustryConstructionStage(), SetIndustryGfx(), SetIndustryTriggers(), SetLiftDestination(), SetLiftPosition(), SetPresentSignals(), SetRailType(), SetRailwayStationReservation(), SetSignalStates(), SetTileHeight(), SetTileType(), SetTrackBits(), SetTrackReservation(), SetTreeCounter(), SetTreeGroundDensity(), SetTreeGrowth(), SetTropicZone(), SetTunnelBridgeReservation(), SetTunnelBridgeSnowOrDesert(), Window::SetWidgetDisabledState(), Window::SetWidgetHiddenState(), Window::SetWidgetLoweredState(), UpdateStationAcceptance(), and VerifyOldNameChecksum().

template<typename T>

static FORCEINLINE T SetBit | ( | T & | x,
|  | const uint8 | y |
| ) |  |  | `[inline, static]`

Set a bit in a variable.

This function sets a bit in a variable. The variable is changed and the value is also returned. Parameter y defines the bit and starts at the LSB with 0.

Parameters:

  | x | The variable to set a bit
  | y | The bit position to set

Returns:
  The new value of the old value with the bit set

Definition at line 118 of file bitmath_func.hpp.

Referenced by AddChildSpriteScreen(), AddSortableSpriteToDraw(), BuildTownHouse(), CalculateRefitMasks(), ChangeTownRating(), CmdAutofillTimetable(), CmdBuildAircraft(), CmdBuildAirport(), CmdBuildBuoy(), CmdBuildDock(), CmdBuildRailroadStation(), CmdBuildRailVehicle(), CmdBuildRoadStop(), CmdBuildRoadVeh(), CmdBuildShip(), CmdCloneVehicle(), CmdRemoveRailroadTrack(), CmdRemoveSignalTrack(), CmdSignalTrackHelper(), CmdStartStopVehicle(), ConvertFromOldCompanyManagerFace(), ConvertOldMultiheadToNew(), CopyGRFConfigList(), DeliverGoods(), SettingEntry::Draw(), DrawCatenaryRailway(), RoadStop::FreeBay(), GetAvailableVehicleCargoTypes(), GetCompanyRailtypes(), GetCompanyRoadtypes(), GetCountAndDistanceOfClosestInstance(), GetValidAirports(), IsGoodGRFConfigList(), LoadUnloadVehicle(), lookup_manyofmany(), MapSpriteMappingRecolour(), MarkTrainAsStuck(), NPFSetFlag(), CompanyStationsWindow::OnClick(), StationViewWindow::OnPaint(), SetArticulatedPart(), SetBridgeMiddle(), SetFreeWagon(), SetFrontEngine(), SetLiftDestination(), SetMultiheaded(), SettingsDisableElrail(), SetTrainEngine(), SetTrainWagon(), ShowNewGrfVehicleError(), ToggleInvisibilityWithTransparency(), TownActionBuildStatue(), TrainConsistChanged(), UpdateTownGrowRate(), and VehiclePayment().

template<typename T>

static FORCEINLINE T ToggleBit | ( | T & | x,
|  | const uint8 | y |
| ) |  |  | `[inline, static]`

Toggles a bit in a variable.

This function toggles a bit in a variable. The variable is changed and the value is also returned. Parameter y defines the bit to toggle and starts at the LSB with 0.

Parameters:

  | x | The varliable to toggle the bit
  | y | The bit position to toggle

Returns:
  The new value of the old value with the bit toggled

Definition at line 176 of file bitmath_func.hpp.

Referenced by CmdRailTrackHelper(), CmdReverseTrainDirection(), CmdSignalTrackHelper(), CompanyStationsWindow::OnClick(), ToggleInvisibility(), ToggleTransparency(), ToggleTransparencyLock(), and Window::ToggleWidgetLoweredState().